<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>jquery-cheatsheet</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <p>
      jQuery is a JavaScript library that helps you “do more, write less”. It
      makes many common JavaScript tasks and makes them easier to write. jQuery
      is used by many big companies and developers everywhere. It makes AJAX,
      event handling, document manipulation, and much more, easier and faster.
    </p>
    <p>
      Because jQuery is a JavaScript library you should
      <a href="https://learnxinyminutes.com/docs/javascript/"
        >learn JavaScript first</a
      >
    </p>
    <p>
      <strong>NOTE</strong>: jQuery has fallen out of the limelight in recent
      years, since you can achieve the same thing with the vanilla DOM (Document
      Object Model) API. So the only thing it is used for is a couple of handy
      features, such as the
      <a href="https://api.jqueryui.com/datepicker">jQuery date picker</a>
      (which actually has a standard, unlike the
      <code>&lt;input type="date"&gt;</code> HTML element), and the obvious
      decrease in the code length.
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"></a>
<a class="sourceLine" id="cb1-2" title="2"></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="co">///////////////////////////////////</span></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="co">// 1. Selectors</span></a>
<a class="sourceLine" id="cb1-5" title="5"></a>
<a class="sourceLine" id="cb1-6" title="6"><span class="co">// Selectors in jQuery are used to select an element</span></a>
<a class="sourceLine" id="cb1-7" title="7"><span class="kw">var</span> page <span class="op">=</span> <span class="at">$</span>(window)<span class="op">;</span> <span class="co">// Selects the whole viewport</span></a>
<a class="sourceLine" id="cb1-8" title="8"></a>
<a class="sourceLine" id="cb1-9" title="9"><span class="co">// Selectors can also be CSS selector</span></a>
<a class="sourceLine" id="cb1-10" title="10"><span class="kw">var</span> paragraph <span class="op">=</span> <span class="at">$</span>(<span class="st">&#39;p&#39;</span>)<span class="op">;</span> <span class="co">// Selects all paragraph elements</span></a>
<a class="sourceLine" id="cb1-11" title="11"><span class="kw">var</span> table1 <span class="op">=</span> <span class="at">$</span>(<span class="st">&#39;#table1&#39;</span>)<span class="op">;</span> <span class="co">// Selects element with id &#39;table1&#39;</span></a>
<a class="sourceLine" id="cb1-12" title="12"><span class="kw">var</span> squares <span class="op">=</span> <span class="at">$</span>(<span class="st">&#39;.square&#39;</span>)<span class="op">;</span> <span class="co">// Selects all elements with the class &#39;square&#39;</span></a>
<a class="sourceLine" id="cb1-13" title="13"><span class="kw">var</span> square_p <span class="op">=</span> <span class="at">$</span>(<span class="st">&#39;p.square&#39;</span>) <span class="co">// Selects paragraphs with the &#39;square&#39; class</span></a>
<a class="sourceLine" id="cb1-14" title="14"></a>
<a class="sourceLine" id="cb1-15" title="15"></a>
<a class="sourceLine" id="cb1-16" title="16"><span class="co">///////////////////////////////////</span></a>
<a class="sourceLine" id="cb1-17" title="17"><span class="co">// 2. Events and Effects</span></a>
<a class="sourceLine" id="cb1-18" title="18"><span class="co">// jQuery is very good at handling what happens when an event is triggered</span></a>
<a class="sourceLine" id="cb1-19" title="19"><span class="co">// A very common event used is the ready event on the document</span></a>
<a class="sourceLine" id="cb1-20" title="20"><span class="co">// You can use the &#39;ready&#39; method to wait until the element has finished loading</span></a>
<a class="sourceLine" id="cb1-21" title="21"><span class="at">$</span>(document).<span class="at">ready</span>(<span class="kw">function</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-22" title="22">  <span class="co">// Code won&#39;t execute until the document is loaded</span></a>
<a class="sourceLine" id="cb1-23" title="23"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-24" title="24"><span class="co">// You can also use defined functions</span></a>
<a class="sourceLine" id="cb1-25" title="25"><span class="kw">function</span> <span class="at">onAction</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb1-26" title="26">  <span class="co">// This is executed when the event is triggered</span></a>
<a class="sourceLine" id="cb1-27" title="27"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-28" title="28"><span class="at">$</span>(<span class="st">&#39;#btn&#39;</span>).<span class="at">click</span>(onAction)<span class="op">;</span> <span class="co">// Invokes onAction on click</span></a>
<a class="sourceLine" id="cb1-29" title="29"></a>
<a class="sourceLine" id="cb1-30" title="30"><span class="co">// Some other common events are:</span></a>
<a class="sourceLine" id="cb1-31" title="31"><span class="at">$</span>(<span class="st">&#39;#btn&#39;</span>).<span class="at">dblclick</span>(onAction)<span class="op">;</span> <span class="co">// Double click</span></a>
<a class="sourceLine" id="cb1-32" title="32"><span class="at">$</span>(<span class="st">&#39;#btn&#39;</span>).<span class="at">hover</span>(onAction)<span class="op">;</span> <span class="co">// Hovering over</span></a>
<a class="sourceLine" id="cb1-33" title="33"><span class="at">$</span>(<span class="st">&#39;#btn&#39;</span>).<span class="at">focus</span>(onAction)<span class="op">;</span> <span class="co">// On focus</span></a>
<a class="sourceLine" id="cb1-34" title="34"><span class="at">$</span>(<span class="st">&#39;#btn&#39;</span>).<span class="at">blur</span>(onAction)<span class="op">;</span> <span class="co">// Losses focus</span></a>
<a class="sourceLine" id="cb1-35" title="35"><span class="at">$</span>(<span class="st">&#39;#btn&#39;</span>).<span class="at">submit</span>(onAction)<span class="op">;</span> <span class="co">// On submit</span></a>
<a class="sourceLine" id="cb1-36" title="36"><span class="at">$</span>(<span class="st">&#39;#btn&#39;</span>).<span class="at">select</span>(onAction)<span class="op">;</span> <span class="co">// When an element is selected</span></a>
<a class="sourceLine" id="cb1-37" title="37"><span class="at">$</span>(<span class="st">&#39;#btn&#39;</span>).<span class="at">keydown</span>(onAction)<span class="op">;</span> <span class="co">// When a key is pushed down</span></a>
<a class="sourceLine" id="cb1-38" title="38"><span class="at">$</span>(<span class="st">&#39;#btn&#39;</span>).<span class="at">keyup</span>(onAction)<span class="op">;</span> <span class="co">// When a key is released</span></a>
<a class="sourceLine" id="cb1-39" title="39"><span class="at">$</span>(<span class="st">&#39;#btn&#39;</span>).<span class="at">keypress</span>(onAction)<span class="op">;</span> <span class="co">// When a key is pressed</span></a>
<a class="sourceLine" id="cb1-40" title="40"><span class="at">$</span>(<span class="st">&#39;#btn&#39;</span>).<span class="at">mousemove</span>(onAction)<span class="op">;</span> <span class="co">// When the mouse is moved</span></a>
<a class="sourceLine" id="cb1-41" title="41"><span class="at">$</span>(<span class="st">&#39;#btn&#39;</span>).<span class="at">mouseenter</span>(onAction)<span class="op">;</span> <span class="co">// Mouse enters the element</span></a>
<a class="sourceLine" id="cb1-42" title="42"><span class="at">$</span>(<span class="st">&#39;#btn&#39;</span>).<span class="at">mouseleave</span>(onAction)<span class="op">;</span> <span class="co">// Mouse leaves the element</span></a>
<a class="sourceLine" id="cb1-43" title="43"></a>
<a class="sourceLine" id="cb1-44" title="44"></a>
<a class="sourceLine" id="cb1-45" title="45"><span class="co">// These can all also trigger the event instead of handling it</span></a>
<a class="sourceLine" id="cb1-46" title="46"><span class="co">// by simply not giving any parameters</span></a>
<a class="sourceLine" id="cb1-47" title="47"><span class="at">$</span>(<span class="st">&#39;#btn&#39;</span>).<span class="at">dblclick</span>()<span class="op">;</span> <span class="co">// Fires double click on the element</span></a>
<a class="sourceLine" id="cb1-48" title="48"></a>
<a class="sourceLine" id="cb1-49" title="49"><span class="co">// You can handle multiple events while only using the selector once</span></a>
<a class="sourceLine" id="cb1-50" title="50"><span class="at">$</span>(<span class="st">&#39;#btn&#39;</span>).<span class="at">on</span>(</a>
<a class="sourceLine" id="cb1-51" title="51">  <span class="op">{</span><span class="dt">dblclick</span><span class="op">:</span> myFunction1<span class="op">}</span> <span class="co">// Triggered on double click</span></a>
<a class="sourceLine" id="cb1-52" title="52">  <span class="op">{</span><span class="dt">blur</span><span class="op">:</span> myFunction1<span class="op">}</span> <span class="co">// Triggered on blur</span></a>
<a class="sourceLine" id="cb1-53" title="53">)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-54" title="54"></a>
<a class="sourceLine" id="cb1-55" title="55"><span class="co">// You can move and hide elements with some effect methods</span></a>
<a class="sourceLine" id="cb1-56" title="56"><span class="at">$</span>(<span class="st">&#39;.table&#39;</span>).<span class="at">hide</span>()<span class="op">;</span> <span class="co">// Hides the element(s)</span></a>
<a class="sourceLine" id="cb1-57" title="57"></a>
<a class="sourceLine" id="cb1-58" title="58"><span class="co">// Note: calling a function in these methods will still hide the element</span></a>
<a class="sourceLine" id="cb1-59" title="59"><span class="at">$</span>(<span class="st">&#39;.table&#39;</span>).<span class="at">hide</span>(<span class="kw">function</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-60" title="60">    <span class="co">// Element hidden then function executed</span></a>
<a class="sourceLine" id="cb1-61" title="61"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-62" title="62"></a>
<a class="sourceLine" id="cb1-63" title="63"><span class="co">// You can store selectors in variables</span></a>
<a class="sourceLine" id="cb1-64" title="64"><span class="kw">var</span> tables <span class="op">=</span> <span class="at">$</span>(<span class="st">&#39;.table&#39;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-65" title="65"></a>
<a class="sourceLine" id="cb1-66" title="66"><span class="co">// Some basic document manipulation methods are:</span></a>
<a class="sourceLine" id="cb1-67" title="67"><span class="va">tables</span>.<span class="at">hide</span>()<span class="op">;</span> <span class="co">// Hides element(s)</span></a>
<a class="sourceLine" id="cb1-68" title="68"><span class="va">tables</span>.<span class="at">show</span>()<span class="op">;</span> <span class="co">// Shows (un-hides) element(s)</span></a>
<a class="sourceLine" id="cb1-69" title="69"><span class="va">tables</span>.<span class="at">toggle</span>()<span class="op">;</span> <span class="co">// Changes the hide/show state</span></a>
<a class="sourceLine" id="cb1-70" title="70"><span class="va">tables</span>.<span class="at">fadeOut</span>()<span class="op">;</span> <span class="co">// Fades out</span></a>
<a class="sourceLine" id="cb1-71" title="71"><span class="va">tables</span>.<span class="at">fadeIn</span>()<span class="op">;</span> <span class="co">// Fades in</span></a>
<a class="sourceLine" id="cb1-72" title="72"><span class="va">tables</span>.<span class="at">fadeToggle</span>()<span class="op">;</span> <span class="co">// Fades in or out</span></a>
<a class="sourceLine" id="cb1-73" title="73"><span class="va">tables</span>.<span class="at">fadeTo</span>(<span class="fl">0.5</span>)<span class="op">;</span> <span class="co">// Fades to an opacity (between 0 and 1)</span></a>
<a class="sourceLine" id="cb1-74" title="74"><span class="va">tables</span>.<span class="at">slideUp</span>()<span class="op">;</span> <span class="co">// Slides up</span></a>
<a class="sourceLine" id="cb1-75" title="75"><span class="va">tables</span>.<span class="at">slideDown</span>()<span class="op">;</span> <span class="co">// Slides down</span></a>
<a class="sourceLine" id="cb1-76" title="76"><span class="va">tables</span>.<span class="at">slideToggle</span>()<span class="op">;</span> <span class="co">// Slides up or down</span></a>
<a class="sourceLine" id="cb1-77" title="77"></a>
<a class="sourceLine" id="cb1-78" title="78"><span class="co">// All of the above take a speed (milliseconds) and callback function</span></a>
<a class="sourceLine" id="cb1-79" title="79"><span class="va">tables</span>.<span class="at">hide</span>(<span class="dv">1000</span><span class="op">,</span> myFunction)<span class="op">;</span> <span class="co">// 1 second hide animation then function</span></a>
<a class="sourceLine" id="cb1-80" title="80"></a>
<a class="sourceLine" id="cb1-81" title="81"><span class="co">// fadeTo has a required opacity as its second parameter</span></a>
<a class="sourceLine" id="cb1-82" title="82"><span class="va">tables</span>.<span class="at">fadeTo</span>(<span class="dv">2000</span><span class="op">,</span> <span class="fl">0.1</span><span class="op">,</span> myFunction)<span class="op">;</span> <span class="co">// 2 sec. fade to 0.1 opacity then function</span></a>
<a class="sourceLine" id="cb1-83" title="83"></a>
<a class="sourceLine" id="cb1-84" title="84"><span class="co">// You can get slightly more advanced with the animate method</span></a>
<a class="sourceLine" id="cb1-85" title="85"><span class="va">tables</span>.<span class="at">animate</span>(<span class="op">{</span>margin<span class="op">-</span><span class="dt">top</span><span class="op">:</span><span class="st">&quot;+=50&quot;</span><span class="op">,</span> <span class="dt">height</span><span class="op">:</span> <span class="st">&quot;100px&quot;</span><span class="op">},</span> <span class="dv">500</span><span class="op">,</span> myFunction)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-86" title="86"><span class="co">// The animate method takes an object of css and values to end with,</span></a>
<a class="sourceLine" id="cb1-87" title="87"><span class="co">// optional options parameter to tune the animation,</span></a>
<a class="sourceLine" id="cb1-88" title="88"><span class="co">// and of course the callback function</span></a>
<a class="sourceLine" id="cb1-89" title="89"></a>
<a class="sourceLine" id="cb1-90" title="90"><span class="co">///////////////////////////////////</span></a>
<a class="sourceLine" id="cb1-91" title="91"><span class="co">// 3. Manipulation</span></a>
<a class="sourceLine" id="cb1-92" title="92"></a>
<a class="sourceLine" id="cb1-93" title="93"><span class="co">// These are similar to effects but can do more</span></a>
<a class="sourceLine" id="cb1-94" title="94"><span class="at">$</span>(<span class="st">&#39;div&#39;</span>).<span class="at">addClass</span>(<span class="st">&#39;taming-slim-20&#39;</span>)<span class="op">;</span> <span class="co">// Adds class taming-slim-20 to all div</span></a>
<a class="sourceLine" id="cb1-95" title="95"></a>
<a class="sourceLine" id="cb1-96" title="96"><span class="co">// Common manipulation methods</span></a>
<a class="sourceLine" id="cb1-97" title="97"><span class="at">$</span>(<span class="st">&#39;p&#39;</span>).<span class="at">append</span>(<span class="st">&#39;Hello world&#39;</span>)<span class="op">;</span> <span class="co">// Adds to end of element</span></a>
<a class="sourceLine" id="cb1-98" title="98"><span class="at">$</span>(<span class="st">&#39;p&#39;</span>).<span class="at">attr</span>(<span class="st">&#39;class&#39;</span>)<span class="op">;</span> <span class="co">// Gets attribute</span></a>
<a class="sourceLine" id="cb1-99" title="99"><span class="at">$</span>(<span class="st">&#39;p&#39;</span>).<span class="at">attr</span>(<span class="st">&#39;class&#39;</span><span class="op">,</span> <span class="st">&#39;content&#39;</span>)<span class="op">;</span> <span class="co">// Sets attribute</span></a>
<a class="sourceLine" id="cb1-100" title="100"><span class="at">$</span>(<span class="st">&#39;p&#39;</span>).<span class="at">hasClass</span>(<span class="st">&#39;taming-slim-20&#39;</span>)<span class="op">;</span> <span class="co">// Returns true if it has the class</span></a>
<a class="sourceLine" id="cb1-101" title="101"><span class="at">$</span>(<span class="st">&#39;p&#39;</span>).<span class="at">height</span>()<span class="op">;</span> <span class="co">// Gets height of element or sets height</span></a>
<a class="sourceLine" id="cb1-102" title="102"></a>
<a class="sourceLine" id="cb1-103" title="103"></a>
<a class="sourceLine" id="cb1-104" title="104"><span class="co">// For many manipulation methods, getting info on an element</span></a>
<a class="sourceLine" id="cb1-105" title="105"><span class="co">// will ONLY get the first matching element</span></a>
<a class="sourceLine" id="cb1-106" title="106"><span class="at">$</span>(<span class="st">&#39;p&#39;</span>).<span class="at">height</span>()<span class="op">;</span> <span class="co">// Gets only the first &#39;p&#39; tag&#39;s height</span></a>
<a class="sourceLine" id="cb1-107" title="107"></a>
<a class="sourceLine" id="cb1-108" title="108"><span class="co">// You can use each to loop through all the elements</span></a>
<a class="sourceLine" id="cb1-109" title="109"><span class="kw">var</span> heights <span class="op">=</span> []<span class="op">;</span></a>
<a class="sourceLine" id="cb1-110" title="110"><span class="at">$</span>(<span class="st">&#39;p&#39;</span>).<span class="at">each</span>(<span class="kw">function</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb1-111" title="111">  <span class="va">heights</span>.<span class="at">push</span>(<span class="at">$</span>(<span class="kw">this</span>).<span class="at">height</span>())<span class="op">;</span> <span class="co">// Adds all &#39;p&#39; tag heights to array</span></a>
<a class="sourceLine" id="cb1-112" title="112"><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-113" title="113"></a></code></pre>
    </div>
    <h2 id="further-reading">Further Reading</h2>
    <ul>
      <li>
        <a href="https://www.codecademy.com/learn/learn-jquery"
          >Codecademy - jQuery</a
        >
        A good introduction to jQuery in a “learn by doing it” format.
      </li>
    </ul>
  </body>
</html>
